//+------------------------------------------------------------------+
//|                                                          ATR.mq5 |
//|                                                      IshaninProd |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "IshaninProd"
#property link      ""
#property version   "1.00"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_plots   1
//--- plot ATR
#property indicator_label1  "ATR"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1


#include <Arrays\ArrayDouble.mqh> 
//--- input parameters
input int      ATRPeriod=5;
//--- indicator buffers
double         ATRBuffer[];
MqlDateTime count;
MqlDateTime date;
CArrayDouble dayATR;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,ATRBuffer,INDICATOR_DATA);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
      
      double maxPrice = high[0];
      double atrMassive[5];
      double minPrice = low[0];
      ATRBuffer[0] = 0;
      double AverageATR = 0;
      bool findHistory = false;
      for(int i=1;i<rates_total;i++)
      {
         TimeToStruct(time[i],date);
         TimeToStruct(time[i-1],count);
         if(date.day != count.day)
         {
            dayATR.Add(maxPrice - minPrice);
            maxPrice = high[i];
            minPrice = low[i];
            if(dayATR.Total() > ATRPeriod)
            {
               dayATR.Delete(0);
            }  
            if(dayATR.Total() < ATRPeriod)
            {
               continue;
            
            }
            for(int j = 0;j<ATRPeriod;j++)
            {
               atrMassive[j] = dayATR[j];
               AverageATR += dayATR[j];
            }
            ATRBuffer[i] = AverageATR / ATRPeriod;
            AverageATR = 0;
         }
         else
         {
            ATRBuffer[i] = ATRBuffer[i-1];
            if (high[i] > maxPrice)
                {
                    maxPrice = high[i];
                }
                if (low[i] < minPrice)
                {
                    minPrice = low[i];
                }
         }
      }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
